# Contributing to OpenMaple #

We're an open community here. After all, the whole project is 
[public domain][pdl]. As such, our goal is to make it as easy as possible to 
contribute to this emulator. As a result, we aim to be fairly lenient on 
contributing. However, there are still some requirements. 

First and foremost, all contributors must declare their work on this project to 
be public domain using our [Contributor Licensing Agreement][cla]. Once that's 
done, contributions may be accepted. However, before that, it simply won't be 
possible. We hate the formality of it all, but it is unfortunately required by 
copyright laws to protect against ownership claims. Ultimately, in taking the 
short time required to do this, you're helping to ensure the true freedom of 
this software by officially dedicating your work to the public domain.

Secondly, we reserve the right to reject merging your changes upstream if 
they're deemed to not fall in line with what we're looking for. We'll try to be 
reasonable with contributions, but sometimes things just don't work out. It's 
unfortunate, but sometimes contributions might just not belong. Thankfully, 
even if we don't like your changes, you can continue to work on it to your 
heart's content. You can continue to maintain your fork against the official 
OpenMaple branch or you can shoot off by yourself. It's public domain, so you 
have complete freedom.

Thirdly and finally, we don't accept merges that assert style changes onto the 
project. We simply don't need a back-and-forth of style changes between 
contributors. So, please don't include anything of that sort, and try to write 
your contributions in a style similar to that of existing code. If you fail to 
match our style sufficiently, we'll comment on your pull request explaining 
what needs to be changed. If the changes are minor or the patch is critical, 
we'll often merge it and simply refactor it ourselves. There are no strict 
style guidelines here. Please just use good judgement when it comes to 
determining what fits with existing code.

[pdl]: <http://unlicense.org/>                                      "Unlicense"
[cla]: <http://www.clahub.com/agreements/aaronweiss74/OpenMaple>    "CLA"